Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 419705 - dev-util/kbuild - kmk_sed fails when build with gcc-4.7 (e.g. Virtualbox)
Summary: dev-util/kbuild - kmk_sed fails when build with gcc-4.7 (e.g. Virtualbox)
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: Current packages (show other bugs)
Hardware: All Linux
: Normal normal (vote)
Assignee: Lars Wendler (Polynomial-C)
URL: http://lists.fedoraproject.org/piperm...
Whiteboard:
Keywords:
Depends on:
Blocks: gcc-4.7
  Show dependency tree
 
Reported: 2012-06-05 06:53 UTC by Justin Lecher (RETIRED)
Modified: 2012-06-20 20:04 UTC (History)
2 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments
vbox build.log (virtualbox-4.1.16:20120605-064435.log,17.36 KB, text/plain)
2012-06-05 06:58 UTC, Justin Lecher (RETIRED)
Details
Patch for kbuild building with gcc 4.7 (kbuild-0.1.9998_pre20110817-gcc-4.7.patch,521 bytes, patch)
2012-06-16 21:06 UTC, Brennan Shacklett
Details | Diff
Patch for ebuild to include previous patch (kbuild-0.1.9998_pre20110817.ebuild-gcc-4.7.patch,450 bytes, patch)
2012-06-16 21:12 UTC, Brennan Shacklett
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Justin Lecher (RETIRED) gentoo-dev 2012-06-05 06:53:26 UTC
From Virtualbox build.log

  GEN     {T}/Runtime/errmsgdata.h
  CXX     RuntimeBldProg - {C}/src/VBox/Runtime/common/err/RTErrConvertFromErrno.cpp
  CXX     RuntimeBldProg - {C}/src/VBox/Runtime/common/err/RTErrConvertToErrno.cpp
/usr/bin/kmk_sed: file /var/tmp/portage/app-emulation/virtualbox-4.1.16/work/VirtualBox-4.1.16/src/VBox/Runtime/common/err/errmsg.sed line 31: Unmatched [ or [^
kmk: *** [/var/tmp/portage/app-emulation/virtualbox-4.1.16/work/VirtualBox-4.1.16/out/linux.amd64/release/obj/Runtime/errmsgdata.h] Error 1
kmk: *** Deleting file `/var/tmp/portage/app-emulation/virtualbox-4.1.16/work/VirtualBox-4.1.16/out/linux.amd64/release/obj/Runtime/errmsgdata.h'


Virtualbox upstream bug:
https://www.virtualbox.org/ticket/10160

Kbuild upstream:
http://svn.netlabs.org/kbuild/ticket/112

Same happend on fedora:
http://lists.fedoraproject.org/pipermail/devel/2012-January/161652.html




$ einfo =app-emulation/virtualbox-4.1.16
Portage 2.2.0_alpha109 (default/linux/amd64/10.0, gcc-4.7.0-asneeded, glibc-2.15-r2, 3.4.0-lh x86_64)
=================================================================
                        System Settings
=================================================================
System uname: Linux-3.4.0-lh-x86_64-Intel-R-_Core-TM-_i7-2600_CPU_@_3.40GHz-with-gentoo-2.1
Timestamp of tree: Mon, 04 Jun 2012 05:30:01 +0000
ccache version 3.1.7 [enabled]
app-shells/bash:          4.2_p29
dev-java/java-config:     2.1.11-r3
dev-lang/python:          2.6.8, 2.7.3-r2, 3.1.5, 3.2.3-r1
dev-util/ccache:          3.1.7
dev-util/cmake:           2.8.8-r2
dev-util/pkgconfig:       0.26
sys-apps/baselayout:      2.1-r1
sys-apps/openrc:          0.10.2
sys-apps/sandbox:         2.5
sys-devel/autoconf:       2.13, 2.69
sys-devel/automake:       1.9.6-r3, 1.10.3, 1.11.5, 1.12.1
sys-devel/binutils:       2.22-r1
sys-devel/gcc:            4.4.7, 4.5.3-r2, 4.6.3, 4.7.0
sys-devel/gcc-config:     1.7.2
sys-devel/libtool:        2.4.2
sys-devel/make:           3.82-r3
sys-kernel/linux-headers: 3.4 (virtual/os-headers)
sys-libs/glibc:           2.15-r2
Repositories: gentoo sunrise bicatali betagarden dummy neurogeek science last-hope g-ctan
Installed sets: 
ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -pipe -ftracer -march=corei7-avx -mtune=corei7-avx -mcx16 -msahf -mno-movbe -maes -mpclmul -mpopcnt -mno-abm -mno-lwp -mno-fma -mno-fma4 -mno-xop -mno-bmi -mno-bmi2 -mno-tbm -mavx -mno-avx2 -msse4.2 -msse4.1 -mno-lzcnt --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=8192  -Wimplicit-function-declaration"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/eselect/ /usr/share/gnupg/qualified.txt /usr/share/nano/ /usr/share/openvpn/easy-rsa /var/lib/hsqldb /var/spool/torque"
CONFIG_PROTECT_MASK="${EPREFIX}/etc/gconf /etc/ca-certificates.conf /etc/dconf /etc/env.d /etc/env.d/java/ /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-O2 -pipe -ftracer -march=corei7-avx -mtune=corei7-avx -mcx16 -msahf -mno-movbe -maes -mpclmul -mpopcnt -mno-abm -mno-lwp -mno-fma -mno-fma4 -mno-xop -mno-bmi -mno-bmi2 -mno-tbm -mavx -mno-avx2 -msse4.2 -msse4.1 -mno-lzcnt --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=8192  -Wenum-compare"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS="--jobs=4 --load-average=12 -t --keep-going --autounmask-write --autounmask --quiet-build=n"
FEATURES="assume-digests binpkg-logs buildsyspkg ccache collision-protect distlocks ebuild-locks fixlafiles metadata-transfer multilib-strict news noinfo parallel-fetch parallel-install parse-eapi-ebuild-head preserve-libs protect-owned sandbox sfperms sign split-log splitdebug strict unknown-features-warn unmerge-logs unmerge-orphans userfetch userpriv usersandbox usersync"
FFLAGS="-O2 -pipe -ftracer -march=corei7-avx -mtune=corei7-avx -mcx16 -msahf -mno-movbe -maes -mpclmul -mpopcnt -mno-abm -mno-lwp -mno-fma -mno-fma4 -mno-xop -mno-bmi -mno-bmi2 -mno-tbm -mavx -mno-avx2 -msse4.2 -msse4.1 -mno-lzcnt --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=8192 "
GENTOO_MIRRORS=" /mnt/tmpfs/ http://gentoo.j-schmitz.net/mirror/ ftp://sunsite.informatik.rwth-aachen.de/pub/Linux/gentoo ftp://ftp.tu-clausthal.de/pub/linux/gentoo/"
LANG="en_GB.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed -Wl,-O1 -Wl,--hash-style=gnu -Wl,--sort-common"
LINGUAS="en"
MAKEOPTS="-j16 -l12"
PKGDIR="/usr/portage/packages"
PORTAGE_COMPRESS="xz"
PORTAGE_COMPRESS_FLAGS="-z -e -9 -v"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --human-readable --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/local/overlays/sunrise-reviewed /local/overlays/bicatali /local/overlays/betagarden /local/overlays/dummy /local/overlays/neurogeek /local/overlays/sci /local/overlays/lh/ebuilds /local/overlays/g-ctan"
SYNC="rsync://rsync.gentoo.org/gentoo-portage"
USE="X acl alsa amd64 bash-completion berkdb branding bzip2 cairo caps cli cracklib crypt cups cxx dbus dri fortran gdbm gif gmp gnome gnome-keyring gpm gstreamer gtk iconv icu ipv6 jpeg jpeg2k ldap logrotate mmx mmxext modules mudflap multilib ncurses network-cron nls nptl nsplugin numa opengl openmp pam pcre png pppd pulseaudio qt3support readline session smp sse sse2 sse3 sse4 sse4_1 sse4a ssl startup-notification tcpd threads tiff truetype unicode vaapi vdpau xinerama xorg zlib" ALSA_CARDS="hda-intel" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CALLIGRA_FEATURES="kexi words flow plan sheets stage tables krita karbon braindump" CAMERAS="ptp2" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" DRACUT_MODULES="plymouth" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ubx" GRUB_PLATFORMS="efi-64" INPUT_DEVICES="evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LIBREOFFICE_EXTENSIONS="presenter-console presenter-minimizer" LINGUAS="en" PYTHON_TARGETS="python2_7 python2_6 python3_2 pypy1_8" QEMU_SOFTMMU_TARGETS="i386 x86_64" QEMU_USER_TARGETS="i386 x86_64" RUBY_TARGETS="ruby19" USERLAND="GNU" VIDEO_CARDS="nvidia" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account"
USE_PYTHON="2.6 2.7 3.1 3.2 2.7-pypy-1.8"
Unset:  CPPFLAGS, CTARGET, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_RSYNC_EXTRA_OPTS

=================================================================
                        Package Settings
=================================================================

app-emulation/virtualbox-4.1.16 was built with the following:
USE="additions extensions (multilib) opengl pam pulseaudio qt4 sdk -alsa -doc -headless -java -python -vboxwebsrv -vnc"
CFLAGS="-O2 -pipe -ftracer -march=corei7-avx -mtune=corei7-avx -mcx16 -msahf -mno-movbe -maes -mpclmul -mpopcnt -mno-abm -mno-lwp -mno-fma -mno-fma4 -mno-xop -mno-bmi -mno-tbm -mavx -msse4.2 -msse4.1 --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=8192 -frecord-gcc-switches -g -Wimplicit-function-declaration"
CXXFLAGS="-O2 -pipe -ftracer -march=corei7-avx -mtune=corei7-avx -mcx16 -msahf -mno-movbe -maes -mpclmul -mpopcnt -mno-abm -mno-lwp -mno-fma -mno-fma4 -mno-xop -mno-bmi -mno-tbm -mavx -msse4.2 -msse4.1 --param l1-cache-size=32 --param l1-cache-line-size=64 --param l2-cache-size=8192 -frecord-gcc-switches -g -Wenum-compare"
Comment 1 Justin Lecher (RETIRED) gentoo-dev 2012-06-05 06:54:32 UTC
Is it possible to use system sed instead?
Comment 2 Justin Lecher (RETIRED) gentoo-dev 2012-06-05 06:58:50 UTC
Created attachment 314259 [details]
vbox build.log
Comment 3 Brennan Shacklett 2012-06-16 21:06:41 UTC
Created attachment 315547 [details, diff]
Patch for kbuild building with gcc 4.7

This patch removes an improper attribute given to one of the functions in kbuild's internal copy of sed. The same issue occured with libc and was fixed already, as shown in this url where I found the solution:
http://sources.redhat.com/ml/libc-alpha/2011-12/msg00091.html

With this patch I can successfully build virtualbox using kbuild.
Comment 4 Brennan Shacklett 2012-06-16 21:12:51 UTC
Created attachment 315549 [details, diff]
Patch for ebuild to include previous patch

Here's a patch for the ebuild for convenience.
Comment 5 Harm Geerts 2012-06-18 01:39:57 UTC
attached patch solved this issue for me.
I believe bug 390247 should be added as a blocker for clarity.
Comment 6 Justin Lecher (RETIRED) gentoo-dev 2012-06-20 20:04:48 UTC
+*kbuild-0.1.9998_pre20110817-r1 (20 Jun 2012)
+
+  20 Jun 2012; Justin Lecher <jlec@gentoo.org>
+  +kbuild-0.1.9998_pre20110817-r1.ebuild,
+  +files/kbuild-0.1.9998_pre20110817-gcc-4.7.patch, metadata.xml:
+  Fix for gcc-4.7, #419705; thanks Brennan Shacklett for the patch
+